/******************************************************************
*    Ana's Perimeter Defense System
*		details and setup: 
*			http://www.billporter.info/?p=1109
*
*		Brought to you by:
*              Bill Porter
*              www.billporter.info
*
*  Version history
*	1.0  Created
*
*
*
*      This code is a patchwork hodgepodge. It's a hot mess of an example sketch, a little bit of borrowed code 
*      and code from my early awful years. But it works. 
*
*      Consider yourself warned. 
*	
*  
*This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
<http://www.gnu.org/licenses/>
*
*This work is licensed under the Creative Commons Attribution-ShareAlike 3.0 Unported License. 
*To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/ or
*send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
******************************************************************/

/******************You need these libraries**********************/

#include <XBee.h> //Xbee library. Source: http://code.google.com/p/xbee-arduino/
#include <digitalWriteFast.h>  //Fast IO library. Source: http://code.google.com/p/digitalwritefast/

/*****************************************************************
*****************CONFIGURABLE SETTINGS****************************
******************************************************************/

//DEBUG enable a software serial port for debug messages
//#define DEBUG 

//Lower 32 bits of remote Xbee's address
#define frontdooraddressLSB 0x407B6A26
#define sidedooraddressLSB 0x407C5E11

//How many displays are in the string?
#define BLOCKS 3

//How fast should text scroll? Higher is slower. 
#define SCROLLSPEED 10

//Messages to display
char msgHello[] = "POWER ON, HELLO ANA";
char msgFront[] = "FRONT DOOR";
char msgSide[] = "SIDE GATE";
char msgError[] = "ERROR";
char msgClear[] = "        ";

/*****************************************************************/

/***********DON'T TOUCH THE REST OF THIS!!!!***********************/

/*****************WIRING CONFIGURATION****************************/

//Driver pins for LED Matrix
#define RCLK 2
#define SCK 3
#define GRN_DATA 5
#define RED_DATA 4
#define HCLK 7
#define H_DATA 6

//buzzer
#define BUZZER 8

/*****************************************************************/

/*****************Some Defs***************************************/
//Color cases
#define RED 0
#define GREEN 1
#define YELLOW 2

//The Font Bitmap
byte alphabets[][8] = {
  {0,0,0,0,0},
  {31, 36, 68, 36, 31},
  {127, 73, 73, 73, 54},
  {62, 65, 65, 65, 34},
  {127, 65, 65, 34, 28},
  {127, 73, 73, 65, 65},
  {127, 72, 72, 72, 64},
  {62, 65, 65, 69, 38},
  {127, 8, 8, 8, 127},
  {0, 65, 127, 65, 0},
  {2, 1, 1, 1, 126},
  {127, 8, 20, 34, 65},
  {127, 1, 1, 1, 1},
  {127, 32, 16, 32, 127},
  {127, 32, 16, 8, 127},
  {62, 65, 65, 65, 62},
  {127, 72, 72, 72, 48},
  {62, 65, 69, 66, 61},
  {127, 72, 76, 74, 49},
  {50, 73, 73, 73, 38},
  {64, 64, 127, 64, 64},
  {126, 1, 1, 1, 126},
  {124, 2, 1, 2, 124},
  {126, 1, 6, 1, 126},
  {99, 20, 8, 20, 99},
  {96, 16, 15, 16, 96},
  {67, 69, 73, 81, 97},
  {0x00, 0x00, 0xA0, 0xC0, 0x00, 0x00, 0x00, 0x00},
  (0x00, 0x00, 0x00, 0x03, 0x03, 0x00, 0x00, 0x00),
  (0x00, 0x00, 0x00, 0x03, 0x03, 0x00, 0x00, 0x00),
};

byte alphabet2[8];

//sub-pixel Bitmaps
byte bitmapRed[BLOCKS][8];
byte bitmapGrn[BLOCKS][8];

// I will refer to each group of 8 columns (represented by one matrix) as a Zone.
int numZones = sizeof(bitmapRed) / 8; 
int maxZoneIndex = numZones-1;
int numCols = numZones * 8;

//Start Xbee Library
XBee xbee = XBee();
ZBRxIoSampleResponse ioSample = ZBRxIoSampleResponse();
XBeeAddress64 test = XBeeAddress64();

/***************************************************************/

/**********************DEBUG ENABLE*****************************/
#ifdef DEBUG
#include <NewSoftSerial.h> //For debug, not needed in final product

// Define NewSoftSerial TX/RX pins
// Connect Arduino pin 9 to TX of usb-serial device
uint8_t ssRX = 9;
// Connect Arduino pin 10 to RX of usb-serial device
uint8_t ssTX = 10;
// Remember to connect all devices to a common Ground: XBee, Arduino and USB-Serial device
NewSoftSerial nss(ssRX, ssTX);
#endif
/***************************************************************/

//Lets begin
void setup() { 
  
  //Start Xbee Serial Port
  xbee.begin(9600);
  
  #ifdef DEBUG
  // start soft serial
  nss.begin(9600);
  #endif
  
  //Init pins
  pinMode(RCLK, OUTPUT);
  pinMode(SCK, OUTPUT);
  pinMode(GRN_DATA, OUTPUT);
  pinMode(RED_DATA, OUTPUT);
  pinMode(HCLK, OUTPUT);
  pinMode(H_DATA, OUTPUT);
  pinMode(BUZZER, OUTPUT);
  
  //fix bitmap. My display is Horizontal scanned, Font bitmap is vertical scanned. Has to be rotated. 
  //Yeah I do here, yeah it wastes RAM, so what? Say something! I dare you!
  rotate();
  
  //Don't be rude, say hello!
  scrollText(msgHello, sizeof(msgHello), GREEN);
  scrollText(msgClear, sizeof(msgClear), GREEN);
}

void loop() {
  //attempt to read a packet   
  xbee.readPacket();

  if (xbee.getResponse().isAvailable()) {
    // got something

    if (xbee.getResponse().getApiId() == ZB_IO_SAMPLE_RESPONSE) {
      xbee.getResponse().getZBRxIoSampleResponse(ioSample);

      /***********************DEBUG OUTPUT SECTION***************/
      /******This code only runs if DEBUG is enabled.***********/
      
      #ifdef DEBUG
      nss.print("Received I/O Sample from: ");
      
      nss.print(ioSample.getRemoteAddress64().getMsb(), HEX);  
      nss.print(ioSample.getRemoteAddress64().getLsb(), HEX);  
      nss.println("");
      
      if (ioSample.containsAnalog()) {
        nss.println("Sample contains analog data");
      }

      if (ioSample.containsDigital()) {
        nss.println("Sample contains digtal data");
      }      

       //read analog inputs
      for (int i = 0; i <= 4; i++) {
        if (ioSample.isAnalogEnabled(i)) {
          nss.print("Analog (AI");
          nss.print(i, DEC);
          nss.print(") is ");
          nss.println(ioSample.getAnalog(i), DEC);
        }
      }

       //check digital inputs
      for (int i = 0; i <= 12; i++) {
        if (ioSample.isDigitalEnabled(i)) {
          nss.print("Digital (DI");
          nss.print(i, DEC);
          nss.print(") is ");
          nss.println(ioSample.isDigitalOn(i), DEC);
        }
      }
      #endif
      /*******************************************************/
      
      //see if the pin we want is low
      if (!ioSample.isDigitalOn(1)){
        //Turn on buzzer
        digitalWrite(BUZZER,HIGH);
        
        //lets check to see which radio is is from, and send it to the screen. 
        if (ioSample.getRemoteAddress64().getLsb() == frontdooraddressLSB)
          scrollText(msgFront, sizeof(msgFront), RED); //display "Front" in RED
        else if (ioSample.getRemoteAddress64().getLsb() == sidedooraddressLSB)
          scrollText(msgSide, sizeof(msgSide), YELLOW); //sisplay "Side" in YELLOW
        
        //turn off buzzer
        digitalWrite(BUZZER,LOW);
        
        //CLEAR THE SCREEN 
        scrollText(msgClear, sizeof(msgClear), GREEN); 
          
      } 
    }
    else {
      #ifdef DEBUG
      nss.print("Expected I/O Sample, but got ");
      nss.print(xbee.getResponse().getApiId(), HEX);
      #endif
      scrollText(msgError, sizeof(msgError), GREEN);
      scrollText(msgClear, sizeof(msgClear), GREEN);
    }    
  } 
  else if (xbee.getResponse().isError()) {
    scrollText(msgError, sizeof(msgError), GREEN);
    scrollText(msgClear, sizeof(msgClear), GREEN);
    #ifdef DEBUG
    nss.print("Error reading packet.  Error code: ");  
    nss.println(xbee.getResponse().getErrorCode());
    #endif
  }
}

//corrects bitmap for my display type. 
void rotate(){ 
  
  for (int z = 0; z<sizeof(alphabets) / 8; z++){
  
    for(int i = 0; i < 5; i++){
      for(int y = 0; y<8; y++){
      if(bitRead(alphabets[z][i], y)) bitSet(alphabet2[7-y], 7-i);
      else bitClear(alphabet2[7-y], 7-i);
      }
    }
    memcpy(alphabets[z], alphabet2, 8);
  }
    
}

//Handles scanning of the display. Scans all Horizontal lines once. 
void scanDisplay(){
  
  for(int i = 0; i<8; i++){
     for(int y = 0; y<=BLOCKS - 1; y++)
       myShiftOut(bitmapRed[y][i], bitmapGrn[y][i]);
    if(i == 7)
      digitalWriteFast2(H_DATA, HIGH); //load up the H reg for next pass
    digitalWriteFast2(RCLK, LOW);
    digitalWriteFast2(HCLK, LOW); //in newer revisions of the display, RCLK and HCLK are combined into one pin. 
    digitalWriteFast2(HCLK, HIGH);
    digitalWriteFast2(RCLK, HIGH);
    if(i == 7)
      digitalWriteFast2(H_DATA, LOW);
    delayMicroseconds(500);
  }

}

//(Almost) Parrallel shifting of 2 bytes. 
void myShiftOut(byte red, byte green){
  
 for(int i = 0; i<8; i++){
  digitalWriteFast2(RED_DATA, bitRead(red, i));
  digitalWriteFast2(GRN_DATA, bitRead(green, i));
  digitalWriteFast2(SCK, HIGH);
  digitalWriteFast2(SCK, LOW);
 }
}

// Converts row and colum to actual bitmap bit and turn it off/on
void PlotRed(int col, int row, bool isOn)
{
  int zone = 0;
  int colBitIndex = col % 8;
  byte colBit = 1 << colBitIndex;
  if (isOn)
    bitmapRed[zone][row] =  bitmapRed[zone][row] | colBit;
  else
    bitmapRed[zone][row] =  bitmapRed[zone][row] & (~colBit);
}

// Converts row and colum to actual bitmap bit and turn it off/on
void PlotGrn(int col, int row, bool isOn)
{
  int zone = 0;
  int colBitIndex = col % 8;
  byte colBit = 1 << colBitIndex;
  if (isOn)
    bitmapGrn[zone][row] =  bitmapGrn[zone][row] | colBit;
  else
    bitmapGrn[zone][row] =  bitmapGrn[zone][row] & (~colBit);
}

// Plot each character of the message one column at a time, updated the display, shift bitmap left.
void scrollText(char msg[], int len, byte color)
{
  
  int alphabetIndex = 0;
  for (int charIndex=0; charIndex < len; charIndex++)
  {
   
    
    if (msg[charIndex] == '.')  alphabetIndex = 29;
    else if (msg[charIndex] == '\'')  alphabetIndex = 27;
    else if (msg[charIndex] < '@') alphabetIndex=0;
    else alphabetIndex = msg[charIndex] - '@';
   
    
    //-- Draw one character of the message --
    // Each character is only 5 columns wide, but I loop 1 more times to create 1 pixel space betwen characters
    for (int col = 0; col<6; col++)
    {
      for (int row = 0; row < 8; row++)
      {
        // Set the pixel to what the alphabet say for columns 0 thru 4, but always leave columns 5 blank.
        bool isOn = 0;
        isOn = bitRead( alphabets[alphabetIndex][row], 7-col ) == 1;
        if(color == 0) {
          PlotRed(0, row, isOn); // We ALWAYS draw on the rightmost column, the shift loop below will scroll it leftward.
          PlotGrn(0, row, 0);
      }
        else if(color == 1)
        {
          PlotGrn(0, row, isOn);  
          PlotRed(0, row, 0);
        }
        else
        {
          PlotGrn(0, row, isOn);  
          PlotRed(0, row, isOn);
        }
    }
      
      //-- The more times you repeat this loop, the slower we would scroll --
      for (int refreshCount=0; refreshCount < SCROLLSPEED; refreshCount++)
        scanDisplay();

      //-- Shift the bitmap one column to left --
      
      for (int row=0; row<8; row++)
      {
        for (int zone=numZones-1; zone >=0; zone--)
        {
          // This right shift would show as a left scroll on display because leftmost column is represented by least significant bit of the byte.
          bitmapRed[zone][row] = bitmapRed[zone][row] << 1;
          bitmapGrn[zone][row] = bitmapGrn[zone][row] << 1;
          
          // Roll over lowest bit from the next zone as highest bit of this zone.
          if (zone <= maxZoneIndex){
            bitWrite(bitmapRed[zone][row], 0, bitRead(bitmapRed[zone-1][row],7));
            bitWrite(bitmapGrn[zone][row], 0, bitRead(bitmapGrn[zone-1][row],7));
          }
        }
      }
    }
    
  }
}
   

